<template>
  <div class="list-show">
    <div class="mt-2 md:mt-8 lg:mt-16 max-w-xl mx-auto">
      <div class="bg-white p-8 shadow rounded-lg">
        <h1 class="text-3xl uppercase font-semibold tracking-wide text-center mb-2">
          <span class="float-left" @click="$router.go(-1)">
            <font-awesome-icon
                icon="long-arrow-alt-left"
                class="text-black"
            ></font-awesome-icon>
          </span> {{list.name}}
        </h1>
        <ul class="max-w-xl mx-auto">
          <form action="#" @submit.prevent="addTask">
            <input type="text" name="email" class="mb-2 rounded w-full shadow p-2  border border-gray-900 tracking-wide text-lg pl-12" placeholder="Add Task" id="task-name" autocomplete="on" v-model="taskCreateParams.name">
          </form>
          <li v-for="task in tasks" :key="task.id"
              class="mb-2 p-2 pl-5 shadow tracking-wide rounded-lg text-xl"
              :class="task.done ? 'text-gray-600 line-through' : 'text-black'"
              @click="changeStatus(task)"
          >
            <font-awesome-icon
                icon="check-circle"
                class="text-gray-600"
                v-if="task.done === true"
            ></font-awesome-icon>
            <font-awesome-icon
                icon="circle"
                class="text-black"
                v-if="task.done === false"
            ></font-awesome-icon>
            <span>
              {{task.name}}
            </span>
            <span @click.prevent="deleteTask(task)">
              <font-awesome-icon
                  icon="trash"
                  class="text-black float-right"
              ></font-awesome-icon>
            </span>
          </li>
        </ul>
      </div>
    </div>
  </div>
</template>

<script>
  import axios from "axios";

  export default {
    name: 'ListShow',
    props: ['listId'],
    data() {
      return {
        list: {},
        tasks: [],
        taskCreateParams: {}
      }
    },
    methods: {
      async checkUserLoggedIn() {
        if(localStorage.getItem('currentUser')!==undefined){
          try {
            let response = await axios.get("https://todo-api.spico.tech/api/auth/validate_token", {headers: {Authorization: JSON.parse(localStorage.getItem('currentUser')).Authorization}})
            localStorage.currentUser = JSON.stringify(response.data)
          } catch (err) {
            this.$router.push({name: 'SignIn'})
          }
        }
      },
      async getList() {
        try {
          let response = await axios.get(`https://todo-api.spico.tech/api/lists/${this.$route.params.listId}`, {headers: {Authorization: JSON.parse(localStorage.getItem('currentUser')).Authorization}})
          this.list = response.data
        } catch(err) {}
      },
      async getTasks(listId) {
        try {
          let response = await axios.get(`https://todo-api.spico.tech/api/lists/${listId}/tasks`, {headers: {Authorization: JSON.parse(localStorage.getItem('currentUser')).Authorization}})
          this.tasks = response.data
        } catch(err) {}
      },
      async changeStatus(task) {
        try {
          if(task.done) {
            await axios.put(`https://todo-api.spico.tech/api/lists/${task.list_id}/tasks/${task.id}/todo`, {}, {headers: {Authorization: JSON.parse(localStorage.getItem('currentUser')).Authorization}})
          } else {
            await axios.put(`https://todo-api.spico.tech/api/lists/${task.list_id}/tasks/${task.id}/done`, {}, {headers: {Authorization: JSON.parse(localStorage.getItem('currentUser')).Authorization}})
          }
          this.getTasks(this.list.id)
        } catch(err) {}
      },
      async addTask() {
        try {
          await axios.post(`https://todo-api.spico.tech/api/lists/${this.list.id}/tasks/`, this.taskCreateParams, {headers: {Authorization: JSON.parse(localStorage.getItem('currentUser')).Authorization}})
          this.taskCreateParams = {}
          this.getTasks(this.list.id)
        } catch(err) {}
      },
      async deleteTask(task) {
        try {
          await axios.delete(`https://todo-api.spico.tech/api/lists/${this.list.id}/tasks/${task.id}`, {headers: {Authorization: JSON.parse(localStorage.getItem('currentUser')).Authorization}})
          this.getTasks(this.list.id)
        } catch(err) {}
      }
    },
    mounted() {
      this.checkUserLoggedIn()
      this.currentUser = JSON.parse(localStorage.getItem('currentUser'))
      this.getList()
      this.getTasks(this.$route.params.listId)
    }
  }
</script>